"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = getQueue;
const crud_1 = __importDefault(require("../../../utils/data-fetching/crud"));
function getQueue(_a) {
    return __awaiter(this, arguments, void 0, function* ({ queueId, userId, query, single, }) {
        const tableName = "process_queue";
        let queryQuery = {};
        if (queueId) {
            queryQuery = Object.assign(Object.assign({}, queryQuery), { id: { value: String(queueId) } });
        }
        if (userId) {
            queryQuery = Object.assign(Object.assign({}, queryQuery), { user_id: { value: String(userId) } });
        }
        const getQueue = yield (0, crud_1.default)({
            action: "get",
            table: tableName,
            query: Object.assign(Object.assign({}, query), { query: Object.assign(Object.assign({}, query === null || query === void 0 ? void 0 : query.query), queryQuery) }),
        });
        const queuePayload = getQueue === null || getQueue === void 0 ? void 0 : getQueue.payload;
        return queueId || single ? queuePayload === null || queuePayload === void 0 ? void 0 : queuePayload[0] : queuePayload;
    });
}
