"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = apiGetGrabQueryAndValues;
const sql_generator_1 = __importDefault(require("../functions/dsql/sql/sql-generator"));
function apiGetGrabQueryAndValues({ query, values }) {
    const queryGenObject = typeof query == "string"
        ? undefined
        : (0, sql_generator_1.default)({
            tableName: query.table,
            genObject: query.query,
            dbFullName: query.dbFullName || "__db",
        });
    return {
        query: typeof query == "string"
            ? String(query.replace(/\n|\r|\n\r/g, " ").replace(/ {2,}/g, " "))
            : (queryGenObject === null || queryGenObject === void 0 ? void 0 : queryGenObject.string) || "",
        values: values || (queryGenObject === null || queryGenObject === void 0 ? void 0 : queryGenObject.values),
        valuesString: typeof query == "string"
            ? values
                ? JSON.stringify(values)
                : undefined
            : (queryGenObject === null || queryGenObject === void 0 ? void 0 : queryGenObject.values)
                ? JSON.stringify(queryGenObject.values)
                : undefined,
    };
}
